﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Event: Result (MapResult as Map)
#Event: Anwser (Question as String, Answer as String)

Sub Class_Globals
	Dim TimeAnimation As Int = 400
	
	Private MyMap As Map
	Private ResultMap As Map
	Private MyPanel As Panel
	Private MyScroll As ScrollView
	Private IndexMap As Int
	Private MyTitolo As Label
	Private BPrev As Button
	
	Private MeCallBack As Object
	Private EventName As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Panel As Panel,vCallback As Object, vEventName As String)
	Dim Ac As Panel = Panel
	
	MeCallBack=vCallback
	EventName=vEventName & "_"
	ResultMap.Initialize

	IndexMap=0
	
	MyPanel.Initialize("")
	MyPanel.Color=Colors.ARGB(50,0,0,0)
	MyScroll.Initialize(1000dip)
	Ac.AddView(MyPanel,0,0,100%x,100%y)
	MyPanel.BringToFront
	MyPanel.Elevation=10dip
	MyTitolo=AddTitle("")
	MyPanel.AddView(MyTitolo,0,0,100%x,50dip)
	MyPanel.AddView(MyScroll,0dip,50dip,100%x,100%y-100dip)
	MyPanel.Color=Colors.LightGray
	
	BPrev.Initialize("BPrev")
	LoadDrawableByName(BPrev,"pointer_spot_anchor")
	BPrev.TextColor=Colors.Blue
	BPrev.Text="<"
	BPrev.TextSize=18
	BPrev.Typeface=Typeface.DEFAULT_BOLD
	MyPanel.AddView(BPrev,0,100%y-50dip,55dip,55dip)

	MyMap.Initialize
End Sub

Sub View As View
	Return MyPanel
End Sub

#Region PrivateFunction

Private Sub getCurrentActivity As Activity
	Dim r As Reflector
	r.Target = r.GetActivityBA
	Return r.GetField("vg")
End Sub

Private Sub AddTitle(Question As String) As Label
	Dim L As Label
	
	L.Initialize("")
	L.Color=Colors.White
	L.TextColor=Colors.Black
	L.TextSize=20
	L.Gravity=Gravity.CENTER
	L.Text=Question
	
	Return l
End Sub

Private Sub AddButton(Answer As String,Index As Int) As Button
	Dim B As Button
	
	B.Initialize("Button")
	B.Color=Colors.Blue
	LoadDrawableByName(B,"btn_group_focused_holo_dark")
	b.TextSize=14
	b.Gravity=Gravity.CENTER
	B.Typeface=Typeface.DEFAULT_BOLD
	b.Text=Answer
	B.Tag=Index
	
	Return b
End Sub

Private Sub Button_Click
	Dim B As Button = Sender
	Dim Index As Int = B.Tag
	Dim Question As String = ResultMap.GetKeyAt(Index)
	'Anwser (Question as String, Answer as String)
	
	If SubExists(MeCallBack,EventName & "Anwser") Then CallSub3(MeCallBack,EventName & "Anwser",Question,B.Text)
	ResultMap.Put(Question,B.Text)
	B.BringToFront
	For Each V As View In MyScroll.Panel.GetAllViewsRecursive
		If V<>B Then V.SetVisibleAnimated(TimeAnimation,False)
	Next
	B.SetLayoutAnimated(TimeAnimation,MyScroll.ScrollPosition,0,MyPanel.Width,Min(MyScroll.Panel.Height,MyPanel.Height-1DIP))
		
	Dim l As Long = DateTime.Now+ TimeAnimation + 200
	Do While DateTime.Now<l
		DoEvents
	Loop
	
	Index=Index+1
	If Index<MyMap.Size Then 
		IndexMap=Index
		Vedi(IndexMap)
	Else
		MyPanel.Visible=False
		If SubExists(MeCallBack,EventName & "Result") Then CallSub2(MeCallBack,EventName & "Result",ResultMap)
	End If
End Sub

private Sub Vedi(IndexMenu As Int)
	Dim Altezza As Int = 40dip
	Dim Y As Int = 0
	Dim L As List = MyMap.GetValueAt(IndexMenu)
	
	MyScroll.Panel.Height=0
	If L.IsInitialized Then 
		MyTitolo.Text=MyMap.GetKeyAt(IndexMenu)
		MyScroll.Panel.Color=Colors.Gray
		MyScroll.Panel.RemoveAllViews
		For i=0 To L.Size-1
			MyScroll.Panel.AddView(AddButton(L.Get(i),IndexMenu),10dip,Y,MyScroll.Width-20dip,Altezza-1dip)
			Y=Y+Altezza
		Next
		MyScroll.Panel.Height=y
		End If
End Sub

Sub BPrev_Click
	If IndexMap>0 Then 
		IndexMap=IndexMap-1
		Vedi(IndexMap)
	End If
End Sub

Private Sub LoadDrawableByName(Control As View, ImageName As String) As Boolean
	Dim R As Reflector
	Try
		R.Target = R.GetContext
		R.Target = R.RunMethod("getResources")
		R.Target = R.RunMethod("getSystem")
		Dim ID_Drawable As Int
		ID_Drawable = R.RunMethod4("getIdentifier", Array As Object(ImageName, "drawable", "android"), _
		                                            Array As String("java.lang.String", "java.lang.String", "java.lang.String"))
		R.Target = R.GetContext
		R.Target = R.RunMethod("getResources")
		Control.Background = R.RunMethod2("getDrawable", ID_Drawable, "java.lang.int")
		Return True
		
	Catch
		LogColor("ERROR.LoadDrawableByName:" & LastException.Message, Colors.Red)
		Return False
	End Try
End Sub

#End Region

#Region PubblicFunction

Sub GetResponse(Question As String) As String
	Dim S As String = ResultMap.Get(Question)
	Return s
End Sub

'Position = 0 to n-1
Sub GetPositionResponse(Position As Int) As String
	Dim S As String = ResultMap.GetValueAt(Position)
	Return s
End Sub

Sub AddList(Question As String, Answer() As String)
	Dim L As List
	
	L.Initialize
	For i=0 To Answer.Length-1
		L.Add(Answer(i))
	Next
	MyMap.Put(Question,L)
	' Azzera i risultati
	For i=0 To MyMap.Size-1
		ResultMap.Put(MyMap.GetKeyAt(i),"")
	Next
	
	Vedi(IndexMap)
End Sub

Sub Clear
	MyPanel.Visible=True
	MyMap.Initialize
	ResultMap.Initialize
	MyScroll.Panel.RemoveAllViews
End Sub

Sub Close
	MyPanel.Visible=False
End Sub

Sub RestartMenu
	IndexMap=0
	MyPanel.Visible=True
	Vedi(0)
End Sub

#End Region

